{smcl}
{* *! version 0.13 beta  13mar2014}{...}
{findalias asfradohelp}{...}
{vieweralsosee "" "--"}{...}
{vieweralsosee "[R] help" "help help"}{...}
{viewerjumpto "Syntax" "examplehelpfile##syntax"}{...}
{viewerjumpto "Description" "examplehelpfile##description"}{...}
{viewerjumpto "Options" "examplehelpfile##options"}{...}
{viewerjumpto "Compatibility issues" "examplehelpfile##comp"}{...}
{viewerjumpto "Examples" "examplehelpfile##examples"}{...}
{title:Title}

{phang}
{bf:bhps_ukhls} {hline 2} Aggregate files and produce codebook for BHPS and UKHLS (Understanding Society) panel databases

{marker syntax}{...}
{title:Syntax}

{p 8 17 2}
{cmd:bhps_ukhls}
[{varlist}]
{cmd:using}
{it: masterfile}
[{cmd:,} {it:options}]

{synoptset 20 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Aggregation}
{synopt:{opt m:erge(filelist)}}specify additional files to be aggregated with {it:masterfile}{p_end}
{synopt:{opth bhpsw:aves(numlist)}}specify waves to aggregate from BHPS{p_end}
{synopt:{opth ukhlsw:aves(numlist)}}specify waves to aggregate from UKHLS{p_end}

{syntab:Codebook}
{synopt:{opt var:labcheck}}produce a codebook in excel format helping to check the continuity of {varlist}'s variable labels across waves and files{p_end}
{synopt:{opt val:labcheck}}produce a codebook in excel format helping to check the continuity of {varlist}'s value labels across waves and files{p_end}
{synopt:{opt j:ustcheck}}do not aggregate files but just produce a codebook{p_end}
{synopt:{opt c:ompact}}make the codebook more compact; mostly useful if {varlist} contains many variables{p_end}

{syntab:Misc.}
{synopt:{opth bhpsd:ir(strings)}}specify directory of BHPS files{p_end}
{synopt:{opth ukhlsd:ir(strings)}}specify directory of UKHLS files{p_end}
{synopt:{opt d:ebugmode}}display output from every command executed by {cmd: bhps_ukhls}{p_end}
{synoptline}


{marker description}{...}
{title:Description}

{pstd}
The BHPS ({it:British Household Panel Survey}) and its successor the UKHLS ({it:United Kingdom Household Longitudinal Study},
also known as {it:Understanding Society})
are two panel databases with a rather complex data structure. {cmd: bhps_ukhls} is a program
that helps to aggregate their files altogether, selecting one, several or all waves and variables.
Files are merged altogether using automatically the most appropriate key variable(s), even
if those are not specified in {varlist}.

{pstd}
{cmd:bhps_ukhls} can also generate a codebook for the variables specified in {varlist}.
The produced codebook is saved as an Excel file, and placed into your current working directory.
It contains the labels and the value labels of the variables, for each of the specified waves and each of
the specified files, and organize them visually to facilitate the observation of small changes
in the labelling system. This is useful when you want to extract some variables from the
beginning of the BHPS to the end of the UKHLS and you want to make sure that their meaning
has not changed between both panels. The codebook also helps to visualize instantly in which wave and
file a variable is present or not.

{pstd}
{bf:Installation} {hline 2} To install the program, simply copy/paste the .ado and this .sthlp files in a folder called "b" located in your personal ado directory. The personal ado directory appears after typing the command "adopath" in Stata.

{pstd}
{bf:Aggregation} {hline 2} To use the program, make sure the BHPS/UKHLS data are in the current working directory,
or specify their path using {cmd:bhpsdir({help strings})} and {cmd:ukhlsdir({help strings})} options.
{varlist} should contain none, one or several variable names. Make sure
that the variable names do not contain wave prefix. For example, if you want to extract respondent's gender,
do not type "wsex" (BHPS, wave 'w') or "w_sex" (UKHLS, wave 'w'), but just "sex". You can theoretically use 
all the wildcards allowed by {varlist}. In practice though, only *, ? and ~ are encouraged. For instance,
to extract general happiness from BHPS waves ("wghql") and UKHLS waves ("w_scghql"), just type "*ghql". If no
{varlist} is specified, then all variables will be extracted.

{pstd}
The {cmd:using} {it:masterfile} statement is mandatory. It serves to specify which is the file where all variables
will be collected, and to which all other files specified in the {cmd:merge({it:filelist})} option will be merged
with. {it:masterfile} must not include the path towards the directory of the file.
It should consist of one unique filename and should not contain wave prefix nor ".dta" suffix.
For instance, do not type "windresp.dta" (BHPS, wave 'w') or "w_indresp.dta" (UKHLS, wave 'w') but just "indresp".
Examples of file names are: indresp, indall, indsamp, hhresp, hhsamp, egoalt, jobhist, youth, income, issue, callrec, etc.
Every observation in the {it:masterfile} will be kept, no observations from the {it:filelist} will be added, and
in case of variable conflict between {it:masterfile} and {it:filelist}, no values from the {it:filelist} will serve to
replace {it:masterfile}'s values, except to fill {it:masterfile}'s missing values. {it:masterfile} and {it:filelist}
cannot be files of cross-wave type (files with names starting with "x").

{pstd}
The resulting dataset from {cmd:bhps_ukhls} will erase any preexisting dataset in memory,
and will contain all variables specified in {varlist} that are present in
{it:masterfile} and, if specified, in {it:filelist}, for the desired waves.
The resulting dataset will also contain a variable called "wave", varying from 1 to 21 or more. Waves 1 to 18
correspond to BHPS waves A to R (respectively). Waves 19 to 21 or more correspond to UKHLS waves A to C (respectively)
or more. In addition, other variables not specified in {varlist} may be added to the result. They correspond to the
identifying variable(s) of {it:masterfile} and to the key variable(s) used to merge it with {it:filelist}.
Finally, the labelling system of the resulting dataset is inherited from the latest specified wave:
if the value labels of a variable change from a wave to another, then the data of older waves may be wrongly labelled
and not comparable to later waves. In order to avoid such labelling conflict,
it is advised to run the {cmd:vallabcheck} option and check the resulting Excel codebook.


{marker options}{...}
{title:Options}

{dlgtab:Aggregation}

{phang}
{opt m:erge(filelist)} specify a list of files that will be merged with {it:masterfile}. Do not specify any wave prefix
nor the ".dta" suffix, nor the path towards the directory of the files.
Separate the file names by spaces and do not include quotes. Examples of file names are:
indresp, indall, indsamp, hhresp, hhsamp, egoalt, jobhist, youth, income, issue, callrec, etc. The program will keep
all observations from {it:masterfile}, and will seek variables of {varlist} in {it:masterfile} first,
and then, successively, in all files of {it:filelist}. The sequence of files specified in {it:filelist} will determinate
the order of successive merges. Duplicate files are automatically ejected. Observations present in {it:filelist} but not
in {it:masterfile} are automatically excluded from the result. The key variables for merging are automatically chosen by
the program, they are not required to be specified in {varlist} but will eventually be present in the resulting dataset.

{pmore}In a particular merging, if no key variable serves also as a unique identifying variable, a cartesian product will be done
using the most appropriate key variable. In any case, do not try to merge files you are not sure they make sense together.

{phang}
{opth bhpsw:aves(numlist)} specify the waves from the BHPS. The argument follows the rules of {help numlist}. Any sequence of
numbers is accepted, but the numbers have to be integers between 1 and 18 (inclusive).
These correspond to BHPS waves respectively between A and R.

{pmore}If neither {cmd:bhpswaves({help numlist})}
nor {cmd:ukhlswaves({help numlist})} are specified, then the default is to extract all waves from both panels.

{phang}
{opth ukhlsw:aves(numlist)} specify the waves from the UKHLS. The argument follows the rules of {help numlist}. Any sequence of
numbers is accepted, but the numbers have to be integers at least equal to 1. Waves 1, 2 and 3 correspond for example to UKHLS
waves A, B and C, respectively. Newcoming waves (4, 5, 6...) are authorized and should be compatible with the program. Note
that in the resulting dataset, observations from UKHLS waves 1, 2, 3... will have values wave=19, 20, 21... respectively; but
BHPS waves 1, 2, ... 18 keep these values.

{pmore}If neither {cmd:bhpswaves({help numlist})} nor {cmd:ukhlswaves({help numlist})}
are specified, then the default is to extract all waves from both panels.

{dlgtab:Codebook}

{phang}
{opt var:labcheck} produces a codebook in excel format, called "bhpsukhls_labcheck.xls", directly saved in the current working directory.
Any preexisting file is automatically erased. This option creates a spreadsheet called "varlab" in this excel file. It contains the
variable labels of {varlist} for any specified wave of any specified file in {it:masterfile} and {it:filelist}.
Hence it is useful to directly appraise if there is any substantial change of variable definition across files, or throughout time.

{pmore}If a cell is empty, it generally means that the variable it relates to is missing for that wave or for that file. It can also, but
very rarely, means that a variable without label is present. If the program does not succeed to generate an excel file, then a csv file called
"bhpsukhls_varlab.csv" is generated instead. If {varlist} contains more than 255 variables, option {cmd:compact} is automatically activated
for this option.

{phang}
{opt val:labcheck} produces a codebook in excel format, called "bhpsukhls_labcheck.xls", directly saved
in the current working directory. Any preexisting file is automatically erased. This option creates
as many spreadsheets as they are variables with value labels in {varlist}. Each spreadsheet is called
"vallab_" followed by the name of the variable. The codebook contains
the values and the value labels of variables in {varlist}, for any specified wave of any specified file in {it:masterfile} and {it:filelist}.
Hence it is useful to directly appraise any change in the value system of a variable across panels, waves and/or files; either
due to an increase of categories, a drecrease, or a change in one category. This problem may particularly arise between
BHPS and UKHLS waves.

{pmore}If the program does not succeed to generate an excel file, then csv files are created, called
"bhpsukhls_vallab_name.csv" (with 'name' being replaced by the name of the variable) if option {cmd:compact} is deactivated,
or "bhpsukhls_vallab.csv" otherwise. If {varlist} contains more than 32 variables, option {cmd:compact} is automatically
activated for {cmd:vallabcheck}, and hence, only one spreadsheet is created, called "vallab".

{phang}
{opt j:ustcheck} forces the program to produce and save the codebook(s) without aggregating files. In this case,
there will be no resulting dataset. This option may save considerable computational resource if you only need a codebook.
This option will also save and restore any preexisting dataset in memory.

{pmore}If neither of {cmd:varlabcheck} or of {cmd:vallabcheck} options is specified,
option {cmd:justcheck} will automatically activate both.

{phang}
{opt c:ompact} forces the program to produce a compact codebook. A non-compact "varlab" codebook makes vary the waves
vertically and the variables and files horizontally. When compacted, this codebook makes vary the waves horizontally
and the variables and files vertically. The compact mode is preferable when {varlist} gets important, and is automatically activated
for {cmd:varlabcheck} instead of getting more than 255 columns (variables and files) in the "varlab" spreadsheet.

{pmore} A non-compact "vallab" codebook makes vary the values vertically, the waves horizontally, and the variables and files
vary across spreadsheets. When compacted, this codebook vary the values, variables and files vertically, and the waves horizontally.
The compact mode is preferable when {varlist} gets important, and is automatically activated for {cmd:vallabcheck}
instead of getting more than 32 spreadsheets (variables and files) with "vallab_" stub name.

{dlgtab:Misc.}

{phang}
{opth bhpsd:ir(strings)} is used to specify the directory of BHPS .dta files. For instance, in Linux, you can type
{cmd:bhpsdir(/home/username/BHPS/data/)}; or in Windows: {cmd:bhpsdir(C:\BHPS\data\)}.

{pmore}If this option is not specified, the default behavior is to consider the current working directory as the location
of the BHPS files (if they are needed).

{phang}
{opth ukhlsd:ir(strings)} is used to specify the directory of UKHLS .dta files. For instance, in Linux, you can type
{cmd:ukhlsdir(/home/username/UKHLS/data/)}; or in Windows: {cmd:bhpsdir(C:\UKHLS\data\)}.

{pmore}If this option is not specified, the default behavior is to consider the current working directory as the location
of the UKHLS files (if they are needed).

{phang}
{opt d:ebugmode} is used to display noisily the output of every command used by {cmd:bhps_ukhls}. Other useful debugging
commands, not specific to this program, include {help trace} and {help pause}.


{marker comp}{...}
{title:Compatibility issues}

{pstd}
The program is still in beta version. Since Understanding Society files are only compatible with Stata 12 and later versions, this program has also been written for Stata 12 and later versions. Besides, it does not support cross-wave files
(files which name starts with a "x"). It has been tested for the data files accessible from
ukdataservice.ac.uk with the serial numbers "5151" ("British Household Panel Survey:
Waves 1-18, 1991-2009") and "6614" ("Understanding Society: Waves 1-3, 2009-2012").
Nevertheless, the coding of {cmd:bhps_ukhls} is quite evolutive and should be compatible with newcoming waves
of the UKHLS, provided that a new file with a new identifying variable does not appear. In such latter case,
simply edit the ado file and add the new ID variable at the end of the global macro called "uid".

{pstd}If you experience any trouble or bugs, please send me an e-mail at the address specified at the beginning of the .ado file.


{marker examples}{...}
{title:Examples}

{pstd}Setup and check presence of BHPS and UKHLS files{p_end}
{phang2}{cmd:. global pathbhps C:\BHPS\data\}{p_end}
{phang2}{cmd:. global pathukhls C:\UKHLS\data\}{p_end}
{phang2}{cmd:. ls $pathbhps, wide}{p_end}
{phang2}* there should appear files such as ahhresp.dta, bindresp.dta, etc.{p_end}
{phang2}{cmd:. ls $pathukhls, wide}{p_end}
{phang2}* there should appear files such as a_hhresp.dta, b_indresp.dta, etc.{p_end}

{pstd}Extract General Happiness from BHPS waves 1 to 3, 7, 16 to 18, and UKHLS waves 1 to 3:{p_end}
{phang2}{cmd:. bhps_ukhls *ghql* using indresp, bhpswaves(1/3 7 16/18) ukhlswaves(1/3) bhpsdir($pathbhps) ukhlsdir($pathukhls)}{p_end}

{pstd}Create a unique identifying variable for these observations:{p_end}
{phang2}{cmd:. replace pid=. if pid<1}{p_end}
{phang2}{cmd:. gen double id=pid if pid<.}{p_end}
{phang2}{cmd:. replace id=-pidp if pid>=.}{p_end}
{phang2}{cmd:. egen double upid=group(id)}{p_end}
{phang2}{cmd:. isid upid wave}{p_end}
{phang2}* If output shows no error, (up)id and wave form a unique identifier{p_end}

{pstd}Extract all variables from indresp and indall, in waves 18 of BHPS and 1 of UKHLS; and produce a
codebook of all their variable labels:{p_end}
{phang2}{cmd:. bhps_ukhls using indresp, merge(indall) bhpswaves(18) ukhlswaves(1) varlabcheck bhpsdir($pathbhps) ukhlsdir($pathukhls)}{p_end}

{pstd}Extract all gender-related variables and all general health-variables from UKHLS waves 1/3 (in indresp), Interviewer's number, PSU, Strata (in hhresp), and Sample origin (in indsamp):{p_end}
{phang2}{cmd:. bhps_ukhls *sex* *ghq* intnum psu strata memorig using indresp, merge(hhresp indsamp) ukhlswaves(1/3) bhpsdir($pathbhps) ukhlsdir($pathukhls)}{p_end}
{phang2}{cmd:. bhps_ukhls *sex* *ghq* intnum psu strata memorig using indresp, merge(indsamp hhresp) ukhlswaves(1/3) bhpsdir($pathbhps) ukhlsdir($pathukhls)}{p_end}
{phang2}* the results should always be the same irrespective of the sequence of the argument in merge(), but the order of variables in the resulting datasets will differ{p_end}
    
{pstd}Produce a compact codebook of variable labels and value labels for all general health-related variables in all waves:{p_end}
{phang2}{cmd:. bhps_ukhls *ghq* using indresp, varlabcheck vallabcheck justcheck compact bhpsdir($pathbhps) ukhlsdir($pathukhls)}{p_end}
{phang2}{cmd:. pwd}{p_end}
{phang2}* this is your working directory{p_end}
{phang2}{cmd:. ls,wide}{p_end}
{phang2}* there should appear in your working directory the output file "bhpsukhls_labcheck.xls"{p_end}



